import React,{useRef,useEffect,useState} from 'react';
import ReactDOM from 'react-dom';
import {geoMercator,geoPath,json,select,scaleQuantize,extent} from 'd3';
import {feature} from 'topojson';
// import { legendColor } from 'd3-svg-legend'

const App = () => {
  const svgRef = useRef();
	const legendRef = useRef();
  const svg = select(svgRef.current);
  const legend = select(legendRef.current);
  const [geometry, setGeometry] = useState(null);
	console.log(geometry)
	const width = window.innerWidth;
	const height = window.innerHeight;
  const c2Value = d => d.properties.AREA_;
	

  
  const jsonIndianstate =
    'https://gist.githubusercontent.com/AnimeshN/da2cb5d197bdc0f811a2cda3eaf2e97d/raw/india_state_nfhs4.topojson';;
	const jsonIndiaDistrict = 'https://gist.githubusercontent.com/AnimeshN/7dd993301b4fb2657a221e3f5e148069/raw/india_district_nfhs4.topojson';

  
  useEffect(()=>{
  	json(jsonIndianstate).then(stateTopology =>{
    	const state = stateTopology.objects.india;
      setGeometry(feature(stateTopology,state))

  })
  },[])

  if(geometry){
    
  const area_extent = extent(geometry.features,d=>c2Value(d))
  
  const colorScale  =  d3.scaleSequential()
  .domain(area_extent)
  .interpolator(d3.interpolateRainbow);
  const projection = geoMercator().fitSize([width, height], geometry);
	const pathGenerator = geoPath(projection);
    svg
      .selectAll(".polygon")
      .data(geometry.features)
      .join("path").attr("class", "polygon")
      .attr("d" ,feature => pathGenerator(feature))
    .style("fill", d =>{
          return colorScale(c2Value(d))
      })
    
//     legend.append("g")
//       .attr("class", "legendQuant")
//       .attr("transform", "translate(20,20)")
    
//      myLegend = legendColor()
//       .title(`Legend`)
//       .scale(colorScale);
    
//     legend.select(".legendQuant")
//       .call(myLegend);
  }
  

	return (
    <div>
      <svg className = "svg-map" width={width} height={height} ref={svgRef} ></svg>
    	<svg ref={legendRef}></svg>
     </div> 
  )
};

ReactDOM.render(<App />, document.getElementById('root'));
